MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0024473Open CASCADE[OCCT] OCCT:Foundation Classespublic2013-12-17 14:402019-05-15 14:51
Reporterdbp 
Assigned Tobugmaster 
PrioritynormalSeverityfeature 
StatusclosedResolutionfixed 
PlatformAOSLOS VersionL
Product Version[OCCT] 6.7.0 
Target Version[OCCT] 6.8.0Fixed in Version[OCCT] 6.8.0 
Summary0024473: TKMath, BVH - introduce template-based package for Bounding volume hierarchy structures and tools
DescriptionCurrent BVH implementation introduced in TKOpenGl toolkit for Ray-Tracing rendering has significant re-usage issues. It is suggested to move/extend this functionality to TKMath toolkit as more generalized template-based classes.

Implementing a set of flexible ray-tracing components, that can be used for different rendering and geometrical algorithms: Whitted style ray-tracing, path tracing (includign GPU-based versions), points projection, collision detection, search of nearest mesh elements and others.
Steps To ReproduceThis patch introduces new template-based TKMath/BVH package. A bounding volume hierarchy (BVH) is a tree structure on a set of geometric objects. All geometric objects are wrapped in bounding volumes (BVH package uses axis-aligned bounding boxes - AABB) that are organized into binary tree. This accelerating structure can be used in a wide variety of geometry and graphics algorithms, such as ray-tracing, projecting, collision detection, search of nearest neighbor, frustum culling, efficient selection and others. BVH package includes a variety of BVH building methods, which provide a different balance between construction time and resulted tree quality.
TagsNo tags attached.
Test case numberNot needed
Attached Files

- Relationships
related to 0024503closedbugmaster Open CASCADE TKOpenGl - Porting ray-tracing component on BVH package 
related to 0024307closedapn Open CASCADE TKOpenGl - efficient culling of large number of presentations 
related to 0025411closedbugmaster Open CASCADE BVH package - eliminate warning about hidden overloaded method ::Box 

-  Notes
(0027422)
dbp (developer)
2014-01-09 16:49

Dear kgv,

Could you please review the current version of BVH package (branch CR24473_1)?

In general, all is done. But, there may be issues related to implementation details and design.
(0027505)
dbp (developer)
2014-01-15 17:05

Dear kgv,

the updated version of BVH package are ready in CR24473_1 branch.
Please review.
(0027506)
kgv (developer)
2014-01-15 17:18

Dear bugmaster,

please check compilation on all supported platforms.
Existing functionality has not been affected by the patch - regression testing is not required.
(0027511)
mkv (tester)
2014-01-16 10:14

Dear BugMaster,

Branch CR24473_1 (and products from GIT master) was compiled on Linux and Windows platforms and tested.
SHA-1: b5ef2ed42ea8d65ad6eb19ee2dd912d8077802dc

Number of compiler warnings:

occt component :
Linux: 55 (55 on master)
Windows: 1 (1 on master)

products component :
Linux: 20 (20 on master)
Windows: 2 (2 on master)

- Related Changesets
occt: master 3c4e78f2
Timestamp: 2014-01-15 13:21:18
Author: dbp
Committer: bugmaster
Details ] Diff ]
0024473: TKMath, BVH - introduce template-based package for Bounding volume hierarchy structures and tools
mod - adm/UDLIST Diff ] File ]
add - src/BVH/BVH.cxx Diff ] File ]
add - src/BVH/BVH_BinnedBuilder.hxx Diff ] File ]
add - src/BVH/BVH_BinnedBuilder.lxx Diff ] File ]
add - src/BVH/BVH_Box.hxx Diff ] File ]
add - src/BVH/BVH_Box.lxx Diff ] File ]
add - src/BVH/BVH_Builder.hxx Diff ] File ]
add - src/BVH/BVH_Builder.lxx Diff ] File ]
add - src/BVH/BVH_Geometry.hxx Diff ] File ]
add - src/BVH/BVH_Geometry.lxx Diff ] File ]
add - src/BVH/BVH_Object.hxx Diff ] File ]
add - src/BVH/BVH_Object.lxx Diff ] File ]
add - src/BVH/BVH_ObjectSet.hxx Diff ] File ]
add - src/BVH/BVH_ObjectSet.lxx Diff ] File ]
add - src/BVH/BVH_PrimitiveSet.hxx Diff ] File ]
add - src/BVH/BVH_PrimitiveSet.lxx Diff ] File ]
add - src/BVH/BVH_Properties.cxx Diff ] File ]
add - src/BVH/BVH_Properties.hxx Diff ] File ]
add - src/BVH/BVH_Properties.lxx Diff ] File ]
add - src/BVH/BVH_Set.hxx Diff ] File ]
add - src/BVH/BVH_Set.lxx Diff ] File ]
add - src/BVH/BVH_Sorter.hxx Diff ] File ]
add - src/BVH/BVH_Sorter.lxx Diff ] File ]
add - src/BVH/BVH_SpatialMedianBuilder.hxx Diff ] File ]
add - src/BVH/BVH_SpatialMedianBuilder.lxx Diff ] File ]
add - src/BVH/BVH_SweepPlaneBuilder.hxx Diff ] File ]
add - src/BVH/BVH_SweepPlaneBuilder.lxx Diff ] File ]
add - src/BVH/BVH_Tree.hxx Diff ] File ]
add - src/BVH/BVH_Tree.lxx Diff ] File ]
add - src/BVH/BVH_Triangulation.hxx Diff ] File ]
add - src/BVH/BVH_Triangulation.lxx Diff ] File ]
add - src/BVH/BVH_Types.hxx Diff ] File ]
add - src/BVH/BVH_Types.lxx Diff ] File ]
add - src/BVH/FILES Diff ] File ]
mod - src/NCollection/NCollection_Vec2.hxx Diff ] File ]
mod - src/NCollection/NCollection_Vec3.hxx Diff ] File ]
mod - src/NCollection/NCollection_Vec4.hxx Diff ] File ]
mod - src/TKMath/PACKAGES Diff ] File ]

- Issue History
Date Modified Username Field Change
2013-12-17 14:40 dbp New Issue
2013-12-17 14:40 dbp Assigned To => dbp
2014-01-09 16:49 dbp Note Added: 0027422
2014-01-09 16:49 dbp Assigned To dbp => kgv
2014-01-09 16:49 dbp Status new => feedback
2014-01-14 20:57 kgv Product Version Unscheduled => 6.7.0
2014-01-14 20:57 kgv Target Version Unscheduled => 6.7.1
2014-01-14 20:57 kgv Summary Implementing Ray-Tracing Toolkit for OCCT => TKMath, BVH - introduce template-based package for Bounding volume hierarchy structures and tools
2014-01-14 20:57 kgv Description Updated View Revisions
2014-01-15 17:05 dbp Note Added: 0027505
2014-01-15 17:05 dbp Status feedback => resolved
2014-01-15 17:18 kgv Note Added: 0027506
2014-01-15 17:18 kgv Assigned To kgv => bugmaster
2014-01-15 17:18 kgv Status resolved => reviewed
2014-01-16 07:22 mkv Assigned To bugmaster => mkv
2014-01-16 10:14 mkv Note Added: 0027511
2014-01-16 10:14 mkv Test case number => Not needed
2014-01-16 10:14 mkv Assigned To mkv => bugmaster
2014-01-16 10:14 mkv Status reviewed => tested
2014-01-16 10:23 dbp Relationship added related to 0024503
2014-01-17 20:43 kgv Relationship added related to 0024307
2014-01-21 11:22 bugmaster Changeset attached => occt master 3c4e78f2
2014-01-21 11:22 bugmaster Status tested => verified
2014-01-21 11:22 bugmaster Resolution open => fixed
2014-04-04 12:36 abv Target Version 6.7.1 => 6.8.0
2014-09-29 14:06 dbp Steps to Reproduce Updated View Revisions
2014-10-05 13:23 abv Category OCCT:Visualization => OCCT:Foundation Classes
2014-10-22 16:13 kgv Relationship added related to 0025411
2014-11-11 12:43 aiv Fixed in Version => 6.8.0
2014-11-11 13:02 aiv Status verified => closed
2019-05-15 14:51 kgv Relationship added parent of 0030655


Copyright © 2000 - 2019 MantisBT Team
Powered by Mantis Bugtracker